;---Protected Mode screen scrolling Demo----------------------------------------

.target exe32
.stack 100h
.heap 0,0

.include system32.inc
.include crt32.inc

linecount equ 48
linesize  equ 42

lines db 4Eh,40,'Hello 32BIT DOS world!                  '
db 17h,40,'                                        '
db 1Eh,40,'Dieses CodeX Assembler Demoprogramm ist '
db 1Eh,40,'ebenfalls eine 32 Bit DOS Anwendung und '
db 1Eh,40,'demonstriert Screenscrolling in einem   '
db 1Eh,40,'Fenster von 40x20 Zeichen Gre, das    '
db 1Eh,40,'sich in der Mitte des Bildschirms       '
db 1Eh,40,'befindet.                               '
db 17h,40,'                                        '
db 1Eh,40,'Das Fenster kann mit den Cursortasten   '
db 1Eh,40,'(',24,',',25,')',' hoch und runter gescrollt         '
db 1Eh,40,'werden.                                 '
db 17h,40,'                                        '
db 1Eh,40,'Damit sich das Scrollen lohnt, hier     '
db 1Eh,40,'noch ein paar Zeilen:                   '
db 17h,40,'                                        '
db 17h,40,'                                        '
db 1Fh,40,'       COLOR POWER GRAPHIC              '
db 1Fh,40,'     Casio CFX - 9850G/9950G            '
db 1Fh,40,'       Bedienungsanleitung              '
db 17h,40,'                                        '
db 17h,40,' 1. Tastenmarkierungen...........: 02   '
db 17h,40,' 2. Wahl von Ikonen und Aufrufen        '
db 17h,40,'    von Modi.....................: 03   '
db 17h,40,' 3. Display......................: 12   '
db 17h,40,' 4. Farbeinstellungen............: 15   '
db 17h,40,' 5. Wenn Probleme auftreten......: 17   '
db 17h,40,'                                        '
db 17h,40,' 1-1 Vor Beginn von Rechnungen...: 20   '
db 17h,40,' 1-2 Speicher....................: 21   '
db 17h,40,' 1-3 Option- Men................: 23   '
db 17h,40,' 1-4 Variablendaten- Men........: 24   '
db 17h,40,' 1-5 Programm - Men.............: 24   '
db 17h,40,'                                        '
db 17h,40,' 2-1 Grundrechnungsarten.........: 27   '
db 17h,40,' 2-2 Spezialfunktionen...........: 31   '
db 17h,40,' 2-3 Funktionsrechnungen.........: 33   '
db 17h,40,'                                        '
db 17h,40,' 3-1 Funktionalanalysenmen......: 36   '
db 17h,40,' 3-2 Auflsungsrechnungen........: 41   '
db 17h,40,' 3-3 Differentialrechnungen......: 47   '
db 17h,40,' 3-4 Integrationsrechnungen......: 50   '
db 17h,40,'                                        '
db 17h,40,' 4-1 Wahl des Zahlensystems......: 52   '
db 17h,40,' 4-2 Arithmetische Operationen...: 53   '
db 17h,40,' 4-3 Logikoperationen............: 53   '
db 17h,40,'                                        '
db 1Fh,40,' . . .                                  '

lineoffs dd 0                           ;first line of window

proc reprint                            ;reprint all contents of the text window
  push word 0                           ;goto upper left corner of window, first line is lineoffs                        
  push word 0
  call gotoxy
  pop ecx
  mov ecx,lineoffs

  @m1:                                  ;print 19 times next line
  push ecx
  call printnextline
  pop ecx
  inc ecx

  mov edx,ecx
  sub edx,lineoffs
  cmp edx,19
  jnz @m1
endproc

proc printnextline(dword nextlineoffs)
  mov ecx,nextlineoffs                  ;calculate address of line to be drawn
  imul ecx,ecx,linesize
  add ecx,offset lines

  mov al,[ecx]                          ;each line may have another color
  mov crt.textattr,al

  inc ecx                               ;print ASCII line 
  push ecx
  call print
  pop ecx
endproc

startup:

call systeminit                         ;initialize modules
call initcrt

push word col_darkgrey                  ;put shadow an background of window
call textcolor
call clrscrattr

mov eax,crt.screenw                     ;calc coordinates of 40x20 window to be posted in
mov ebx,crt.screenh                     ;middle of screen, since depends on current video mode
sub ax,40                               ;that can be 40x25, 40x50, 80x25 or 80x50                               
sub bx,20
shr eax,1
shr ebx,1
push eax
push ebx
add ax,39
add bx,19
push eax
push ebx
call setscreenwindow

push word col_blue                      ;set window's background blue and clear stack
call textbackground

@m2:
call reprint                            ;reprint window, wait until key pressed
@mwait:
call readkey

cmp al,27                               ;exit program, since ESC was pressed
jz @mend
cmp al,176                              ;cursor down
jnz @m1
cmp lineoffs,linecount-19
jnb @mwait
inc lineoffs
mov eax,lineoffs
add eax,19
push eax
call printnextline
pop eax
jmp @mwait

@m1:
cmp al,168
jnz @mwait
cmp lineoffs,0
jz @mwait

dec lineoffs
jmp @m2

@mend:

push 0
push 0
push dword crt.screenmaxx
push dword crt.screenmaxy
call setscreenwindow
mov byte crt.textattr,7
call clrscr
push 0
call gotoxy

call halt